/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;
import java.util.concurrent.LinkedBlockingQueue;

@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;
    private final Queue<IToken> nextList = new LinkedBlockingQueue<IToken>();

	private IToken tok;

    public Queue<IToken> getNextList() {
        return nextList;
    }

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
              nextList.add(token);
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return (Token) nextList.peek();
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = (Token) nextList.poll();
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.SHEBANG; break;
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 246:
                        {
                              Token token = new246(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new6(  int line,   int pos) { return new TStar(line, pos); }
    Token new7(  int line,   int pos) { return new TSlash(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new11(  int line,   int pos) { return new TDollar(line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new15(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new16(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new18(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new22(  int line,   int pos) { return new TComma(line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new26(  int line,   int pos) { return new TInsertStartSequence(line, pos); }
    Token new27(  int line,   int pos) { return new TDot(line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TDotPar(text, line, pos); }
    Token new30(  int line,   int pos) { return new TDivision(line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new35(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new37(  int line,   int pos) { return new TRestrictHeadSequence(line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new39(  int line,   int pos) { return new TDoubleColon(line, pos); }
    Token new40(  int line,   int pos) { return new TAssign(line, pos); }
    Token new41(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new42(  int line,   int pos) { return new TLess(line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new45(  int line,   int pos) { return new TInsertEndSequence(line, pos); }
    Token new46(  int line,   int pos) { return new TOutputParameters(line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new53(  int line,   int pos) { return new TEqual(line, pos); }
    Token new54(  int line,   int pos) { return new TDoubleEqual(line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new56(  int line,   int pos) { return new TGreater(line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new59(  int line,   int pos) { return new TPartialBijection(line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new63(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new64(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new65(  int line,   int pos) { return new TAny(line, pos); }
    Token new66(  int line,   int pos) { return new TAssert(line, pos); }
    Token new67(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new68(  int line,   int pos) { return new TBe(line, pos); }
    Token new69(  int line,   int pos) { return new TBegin(line, pos); }
    Token new70(  int line,   int pos) { return new TBool(line, pos); }
    Token new71(  int line,   int pos) { return new TBfalse(line, pos); }
    Token new72(  int line,   int pos) { return new TCase(line, pos); }
    Token new73(  int line,   int pos) { return new TChoice(line, pos); }
    Token new74(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new75(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new76(  int line,   int pos) { return new TConstants(line, pos); }
    Token new77(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new78(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new79(  int line,   int pos) { return new TDo(line, pos); }
    Token new80(  int line,   int pos) { return new TEither(line, pos); }
    Token new81(  int line,   int pos) { return new TElse(line, pos); }
    Token new82(  int line,   int pos) { return new TElsif(line, pos); }
    Token new83(  int line,   int pos) { return new TEnd(line, pos); }
    Token new84(  int line,   int pos) { return new TExtends(line, pos); }
    Token new85(  String text,   int line,   int pos) { return new TFalse(text, line, pos); }
    Token new86(  int line,   int pos) { return new TFin(line, pos); }
    Token new87(  int line,   int pos) { return new TFin1(line, pos); }
    Token new88(  int line,   int pos) { return new TIf(line, pos); }
    Token new89(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new90(  int line,   int pos) { return new TImports(line, pos); }
    Token new91(  int line,   int pos) { return new TIn(line, pos); }
    Token new92(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new93(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new94(  int line,   int pos) { return new TInt(line, pos); }
    Token new95(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new96(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new97(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new98(  int line,   int pos) { return new TLet(line, pos); }
    Token new99(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new100(  int line,   int pos) { return new TMachine(line, pos); }
    Token new101(  int line,   int pos) { return new TModel(line, pos); }
    Token new102(  int line,   int pos) { return new TSystem(line, pos); }
    Token new103(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new104(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new105(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new106(  String text,   int line,   int pos) { return new TNat1(text, line, pos); }
    Token new107(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new108(  int line,   int pos) { return new TNatural1(line, pos); }
    Token new109(  int line,   int pos) { return new TOf(line, pos); }
    Token new110(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new111(  int line,   int pos) { return new TOr(line, pos); }
    Token new112(  int line,   int pos) { return new TPi(line, pos); }
    Token new113(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new114(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new115(  int line,   int pos) { return new TPre(line, pos); }
    Token new116(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new117(  int line,   int pos) { return new TProperties(line, pos); }
    Token new118(  int line,   int pos) { return new TRefines(line, pos); }
    Token new119(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new120(  int line,   int pos) { return new TSees(line, pos); }
    Token new121(  int line,   int pos) { return new TSelect(line, pos); }
    Token new122(  int line,   int pos) { return new TSets(line, pos); }
    Token new123(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new124(  int line,   int pos) { return new TSigma(line, pos); }
    Token new125(  int line,   int pos) { return new TString(line, pos); }
    Token new126(  int line,   int pos) { return new TThen(line, pos); }
    Token new127(  String text,   int line,   int pos) { return new TTrue(text, line, pos); }
    Token new128(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new129(  int line,   int pos) { return new TUses(line, pos); }
    Token new130(  int line,   int pos) { return new TValue(line, pos); }
    Token new131(  int line,   int pos) { return new TVar(line, pos); }
    Token new132(  int line,   int pos) { return new TVariant(line, pos); }
    Token new133(  int line,   int pos) { return new TVariables(line, pos); }
    Token new134(  int line,   int pos) { return new TWhen(line, pos); }
    Token new135(  int line,   int pos) { return new TWhere(line, pos); }
    Token new136(  int line,   int pos) { return new TWhile(line, pos); }
    Token new137(  String text,   int line,   int pos) { return new TEmptySequence(text, line, pos); }
    Token new138(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new139(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new140(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new141(  int line,   int pos) { return new TRestrictTailSequence(line, pos); }
    Token new142(  int line,   int pos) { return new TConcatSequence(line, pos); }
    Token new143(  int line,   int pos) { return new TArity(line, pos); }
    Token new144(  int line,   int pos) { return new TBin(line, pos); }
    Token new145(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new146(  int line,   int pos) { return new TBtree(line, pos); }
    Token new147(  int line,   int pos) { return new TCard(line, pos); }
    Token new148(  int line,   int pos) { return new TClosure(line, pos); }
    Token new149(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new150(  int line,   int pos) { return new TConc(line, pos); }
    Token new151(  int line,   int pos) { return new TConst(line, pos); }
    Token new152(  int line,   int pos) { return new TDom(line, pos); }
    Token new153(  int line,   int pos) { return new TFather(line, pos); }
    Token new154(  int line,   int pos) { return new TFirst(line, pos); }
    Token new155(  int line,   int pos) { return new TFnc(line, pos); }
    Token new156(  int line,   int pos) { return new TFront(line, pos); }
    Token new157(  int line,   int pos) { return new TId(line, pos); }
    Token new158(  int line,   int pos) { return new TInfix(line, pos); }
    Token new159(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new160(  int line,   int pos) { return new TIseq(line, pos); }
    Token new161(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new162(  int line,   int pos) { return new TIterate(line, pos); }
    Token new163(  int line,   int pos) { return new TLast(line, pos); }
    Token new164(  int line,   int pos) { return new TLeft(line, pos); }
    Token new165(  int line,   int pos) { return new TMax(line, pos); }
    Token new166(  int line,   int pos) { return new TMin(line, pos); }
    Token new167(  int line,   int pos) { return new TMirror(line, pos); }
    Token new168(  int line,   int pos) { return new TMod(line, pos); }
    Token new169(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new170(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new171(  int line,   int pos) { return new TPerm(line, pos); }
    Token new172(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new173(  int line,   int pos) { return new TPred(line, pos); }
    Token new174(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new175(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new176(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new177(  int line,   int pos) { return new TRank(line, pos); }
    Token new178(  int line,   int pos) { return new TRan(line, pos); }
    Token new179(  int line,   int pos) { return new TRec(line, pos); }
    Token new180(  int line,   int pos) { return new TRel(line, pos); }
    Token new181(  int line,   int pos) { return new TRev(line, pos); }
    Token new182(  int line,   int pos) { return new TRight(line, pos); }
    Token new183(  int line,   int pos) { return new TSeq(line, pos); }
    Token new184(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new185(  int line,   int pos) { return new TSizet(line, pos); }
    Token new186(  int line,   int pos) { return new TSize(line, pos); }
    Token new187(  int line,   int pos) { return new TSkip(line, pos); }
    Token new188(  int line,   int pos) { return new TSons(line, pos); }
    Token new189(  int line,   int pos) { return new TSon(line, pos); }
    Token new190(  int line,   int pos) { return new TStruct(line, pos); }
    Token new191(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new192(  int line,   int pos) { return new TSucc(line, pos); }
    Token new193(  int line,   int pos) { return new TTail(line, pos); }
    Token new194(  int line,   int pos) { return new TTop(line, pos); }
    Token new195(  int line,   int pos) { return new TTree(line, pos); }
    Token new196(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new197(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new198(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new199(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new200(  int line,   int pos) { return new TVerticalBar(line, pos); }
    Token new201(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new202(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new203(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new204(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new205(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new206(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new207(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new208(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new209(  int line,   int pos) { return new TKwFreetypes(line, pos); }
    Token new210(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new211(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new212(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new213(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new214(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new215(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new216(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new217(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new218(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new219(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new220(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new221(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new222(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new223(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new224(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new225(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new226(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new227(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new228(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new229(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new230(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new231(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new232(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new233(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new234(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new235(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new236(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new237(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new238(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new239(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new240(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new241(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new242(  int line,   int pos) { return new TTruthPredicate(line, pos); }
    Token new243(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new244(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new245(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new246(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {65, 65, 25}, {66, 66, 26}, {67, 67, 27}, {68, 68, 28}, {69, 69, 29}, {70, 70, 30}, {71, 72, 31}, {73, 73, 32}, {74, 75, 31}, {76, 76, 33}, {77, 77, 34}, {78, 78, 35}, {79, 79, 36}, {80, 80, 37}, {81, 81, 31}, {82, 82, 38}, {83, 83, 39}, {84, 84, 40}, {85, 85, 41}, {86, 86, 42}, {87, 87, 43}, {88, 90, 31}, {91, 91, 44}, {92, 92, 45}, {93, 93, 46}, {94, 94, 47}, {95, 95, 48}, {97, 97, 49}, {98, 98, 50}, {99, 99, 51}, {100, 100, 52}, {101, 101, 53}, {102, 102, 54}, {103, 104, 53}, {105, 105, 55}, {106, 107, 53}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 53}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 53}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {127, 160, 1}, {172, 172, 69}, {183, 183, 70}, {215, 215, 71}, {955, 955, 72}, {8206, 8207, 1}, {8229, 8229, 73}, {8232, 8233, 1}, {8469, 8469, 74}, {8473, 8473, 75}, {8484, 8484, 76}, {8594, 8594, 77}, {8596, 8596, 78}, {8608, 8608, 79}, {8611, 8611, 80}, {8614, 8614, 81}, {8658, 8658, 82}, {8660, 8660, 83}, {8696, 8696, 84}, {8704, 8704, 85}, {8707, 8707, 86}, {8709, 8709, 87}, {8712, 8712, 88}, {8713, 8713, 89}, {8722, 8722, 90}, {8741, 8741, 91}, {8743, 8743, 92}, {8744, 8744, 93}, {8745, 8745, 94}, {8746, 8746, 95}, {8764, 8764, 96}, {8800, 8800, 97}, {8804, 8804, 98}, {8805, 8805, 99}, {8834, 8834, 100}, {8836, 8836, 101}, {8838, 8838, 102}, {8840, 8840, 103}, {8855, 8855, 104}, {8868, 8868, 105}, {8869, 8869, 106}, {8898, 8898, 107}, {8899, 8899, 108}, {9655, 9655, 109}, {9665, 9665, 110}, {10496, 10496, 111}, {10516, 10516, 112}, {10518, 10518, 113}, {10852, 10852, 114}, {10853, 10853, 115}, {57600, 57600, 116}, {57601, 57601, 117}, {57602, 57602, 118}, {57603, 57603, 119}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 33, 120}, {34, 34, 121}, {35, 65535, 120}, },
            {{33, 33, 122}, {65, 65, 123}, {67, 67, 124}, {68, 68, 125}, {69, 69, 126}, {70, 70, 127}, {73, 73, 128}, {76, 76, 129}, {79, 79, 130}, {80, 80, 131}, {83, 83, 132}, {85, 85, 133}, {86, 86, 134}, {108, 108, 135}, {112, 112, 136}, {116, 116, 137}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 138}, },
            {{45, 45, 139}, },
            {},
            {{45, 45, 140}, {62, 62, 141}, },
            {{0, 9, 142}, {10, 10, 143}, {11, 12, 142}, {13, 13, 143}, {14, 32, 142}, {40, 40, 144}, {46, 46, 145}, {127, 160, 142}, {8206, 8207, 142}, {8232, 8233, 142}, },
            {{42, 42, 146}, {58, 58, 147}, {60, 60, 148}, {61, 61, 149}, {92, 92, 150}, {124, 124, 151}, },
            {{48, 57, 19}, {120, 120, 152}, },
            {{48, 57, 19}, },
            {{58, 58, 153}, {61, 61, 154}, },
            {},
            {{0, 9, 155}, {10, 10, 156}, {11, 12, 155}, {13, 13, 156}, {14, 32, 155}, {43, 43, 157}, {45, 45, 158}, {58, 58, 159}, {60, 60, 160}, {61, 61, 161}, {62, 62, 162}, {124, 124, 163}, {127, 160, 155}, {8206, 8207, 155}, {8232, 8233, 155}, },
            {{61, 61, 164}, {62, 62, 165}, },
            {{43, 43, 166}, {45, 45, 167}, {60, 60, 168}, {61, 61, 169}, },
            {{48, 57, 170}, {65, 65, 171}, {66, 66, 172}, {67, 77, 171}, {78, 78, 173}, {79, 82, 171}, {83, 83, 174}, {84, 90, 171}, {95, 95, 175}, {97, 122, 176}, },
            {{48, 57, 170}, {65, 68, 171}, {69, 69, 177}, {70, 78, 171}, {79, 79, 178}, {80, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 179}, {66, 71, 171}, {72, 72, 180}, {73, 78, 171}, {79, 79, 181}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 182}, {70, 78, 171}, {79, 79, 183}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 72, 171}, {73, 73, 184}, {74, 75, 171}, {76, 76, 185}, {77, 77, 171}, {78, 78, 186}, {79, 85, 171}, {86, 86, 187}, {87, 87, 171}, {88, 88, 188}, {89, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 189}, {66, 72, 171}, {73, 73, 190}, {74, 81, 171}, {82, 82, 191}, {83, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 69, 171}, {70, 70, 192}, {71, 76, 171}, {77, 77, 193}, {78, 78, 194}, {79, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 195}, {70, 78, 171}, {79, 79, 196}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 197}, {66, 72, 171}, {73, 73, 198}, {74, 78, 171}, {79, 79, 199}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 200}, {66, 90, 171}, {95, 122, -27}, },
            {{48, 69, -34}, {70, 70, 201}, {71, 79, 171}, {80, 80, 202}, {81, 81, 171}, {82, 82, 203}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 204}, {74, 78, 171}, {79, 79, 205}, {80, 81, 171}, {82, 82, 206}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 207}, {70, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 208}, {70, 72, 171}, {73, 73, 209}, {74, 83, 171}, {84, 84, 210}, {85, 88, 171}, {89, 89, 211}, {90, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 71, 171}, {72, 72, 212}, {73, 81, 171}, {82, 82, 213}, {83, 122, -32}, },
            {{48, 57, 170}, {65, 77, 171}, {78, 78, 214}, {79, 82, 171}, {83, 83, 215}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 65, 216}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 217}, {73, 90, 171}, {95, 122, -27}, },
            {{0, 9, 218}, {10, 10, 219}, {11, 12, 218}, {13, 13, 219}, {14, 32, 218}, {93, 93, 220}, {127, 160, 218}, {8206, 8207, 218}, {8232, 8233, 218}, },
            {{47, 47, 221}, {124, 124, 222}, },
            {},
            {},
            {},
            {{48, 95, -33}, {97, 113, 176}, {114, 114, 223}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 101, 176}, {102, 102, 224}, {103, 104, 176}, {105, 105, 225}, {106, 110, 176}, {111, 111, 226}, {112, 115, 176}, {116, 116, 227}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 97, 228}, {98, 107, 176}, {108, 108, 229}, {109, 110, 176}, {111, 111, 230}, {112, 122, 176}, },
            {{48, 95, -33}, {97, 110, 176}, {111, 111, 231}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 97, 232}, {98, 104, 176}, {105, 105, 233}, {106, 109, 176}, {110, 110, 234}, {111, 113, 176}, {114, 114, 235}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 99, 176}, {100, 100, 236}, {101, 109, 176}, {110, 110, 237}, {111, 114, 176}, {115, 115, 238}, {116, 116, 239}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 97, 240}, {98, 100, 176}, {101, 101, 241}, {102, 122, 176}, },
            {{48, 95, -33}, {97, 97, 242}, {98, 104, 176}, {105, 105, 243}, {106, 110, 176}, {111, 111, 244}, {112, 122, 176}, },
            {{48, 110, -54}, {111, 111, 245}, {112, 122, 176}, },
            {{48, 113, -51}, {114, 114, 246}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 100, 176}, {101, 101, 247}, {102, 110, 176}, {111, 111, 248}, {112, 113, 176}, {114, 114, 249}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 97, 250}, {98, 100, 176}, {101, 101, 251}, {102, 104, 176}, {105, 105, 252}, {106, 122, 176}, },
            {{48, 100, -62}, {101, 101, 253}, {102, 104, 176}, {105, 105, 254}, {106, 106, 176}, {107, 107, 255}, {108, 110, 176}, {111, 111, 256}, {112, 115, 176}, {116, 116, 257}, {117, 117, 258}, {118, 122, 176}, },
            {{48, 95, -33}, {97, 97, 259}, {98, 110, 176}, {111, 111, 260}, {112, 113, 176}, {114, 114, 261}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 109, 176}, {110, 110, 262}, {111, 122, 176}, },
            {{0, 9, 263}, {10, 10, 264}, {11, 12, 263}, {13, 13, 264}, {14, 32, 263}, {125, 125, 265}, {127, 160, 263}, {8206, 8207, 263}, {8232, 8233, 263}, },
            {{45, 45, 266}, {62, 62, 267}, {124, 124, 268}, },
            {},
            {},
            {},
            {{0, 9, 269}, {10, 10, 270}, {11, 12, 269}, {13, 13, 270}, {14, 32, 269}, {40, 40, 271}, {127, 160, 269}, {8206, 8207, 269}, {8232, 8233, 269}, },
            {},
            {},
            {},
            {{49, 49, 272}, },
            {{49, 49, 273}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {},
            {{66, 66, 274}, {83, 83, 275}, },
            {{79, 79, 276}, },
            {{69, 69, 277}, },
            {{88, 88, 278}, },
            {{79, 79, 279}, },
            {{77, 77, 280}, {78, 78, 281}, },
            {{79, 79, 282}, },
            {{80, 80, 283}, },
            {{82, 82, 284}, },
            {{69, 69, 285}, {85, 85, 286}, },
            {{83, 83, 287}, },
            {{65, 65, 288}, },
            {{105, 105, 289}, },
            {{114, 114, 290}, },
            {{114, 114, 291}, },
            {},
            {{62, 62, 292}, },
            {{62, 62, 293}, },
            {},
            {{0, 40, -18}, {127, 8233, -18}, },
            {{0, 8233, -144}, },
            {},
            {},
            {},
            {},
            {{58, 58, 294}, {60, 60, 295}, },
            {},
            {},
            {{92, 92, 296}, },
            {{48, 57, 297}, {65, 70, 297}, {97, 102, 297}, },
            {},
            {},
            {{0, 32, -24}, {62, 62, 162}, {127, 8233, -24}, },
            {{0, 8233, -157}, },
            {},
            {{45, 45, 298}, {62, 62, 299}, },
            {},
            {{45, 45, 300}, {58, 58, 301}, {124, 124, 302}, },
            {{62, 62, 303}, },
            {},
            {},
            {},
            {},
            {{62, 62, 304}, },
            {{62, 62, 305}, },
            {},
            {},
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 82, 171}, {83, 83, 306}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 88, 171}, {89, 89, 307}, {90, 122, -41}, },
            {{48, 82, -174}, {83, 83, 308}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 70, 171}, {71, 71, 309}, {72, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 78, 171}, {79, 79, 310}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 311}, {84, 122, -27}, },
            {{48, 78, -180}, {79, 79, 312}, {80, 122, -28}, },
            {{48, 77, -43}, {78, 78, 313}, {79, 122, -34}, },
            {{48, 69, -34}, {70, 70, 314}, {71, 90, 171}, {95, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 83, 171}, {84, 84, 315}, {85, 90, 171}, {95, 122, -27}, },
            {{48, 82, -174}, {83, 83, 316}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 67, 171}, {68, 68, 317}, {69, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 318}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 319}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 75, 171}, {76, 76, 320}, {77, 90, 171}, {95, 122, -27}, },
            {{48, 77, -43}, {78, 78, 321}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 322}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 79, 171}, {80, 80, 323}, {81, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 66, 171}, {67, 67, 324}, {68, 72, 171}, {73, 73, 325}, {74, 83, 171}, {84, 84, 326}, {85, 85, 171}, {86, 86, 327}, {87, 90, 171}, {95, 122, -27}, },
            {{48, 83, -186}, {84, 84, 328}, {85, 122, -186}, },
            {{48, 66, -196}, {67, 67, 329}, {68, 90, 171}, {95, 122, -27}, },
            {{48, 66, -196}, {67, 67, 330}, {68, 87, 171}, {88, 88, 331}, {89, 122, -31}, },
            {{48, 77, -43}, {78, 78, 332}, {79, 122, -34}, },
            {{48, 67, -188}, {68, 68, 333}, {69, 122, -188}, },
            {{48, 83, -186}, {84, 84, 334}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 335}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 86, 171}, {87, 87, 336}, {88, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 337}, {70, 78, 171}, {79, 79, 338}, {80, 122, -28}, },
            {{48, 69, -34}, {70, 70, 339}, {71, 122, -184}, },
            {{48, 68, -28}, {69, 69, 340}, {70, 75, 171}, {76, 76, 341}, {77, 83, 171}, {84, 84, 342}, {85, 122, -186}, },
            {{48, 70, -179}, {71, 71, 343}, {72, 122, -179}, },
            {{48, 57, 170}, {65, 81, 171}, {82, 82, 344}, {83, 122, -32}, },
            {{48, 82, -174}, {83, 83, 345}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 346}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 84, 171}, {85, 85, 347}, {86, 90, 171}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 348}, {74, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 349}, {70, 122, -40}, },
            {{48, 75, -191}, {76, 76, 350}, {77, 81, 171}, {82, 82, 351}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 352}, {70, 72, 171}, {73, 73, 353}, {74, 122, -216}, },
            {{0, 8233, -46}, },
            {{0, 8233, -46}, },
            {},
            {},
            {{47, 47, 354}, },
            {{48, 95, -33}, {97, 104, 176}, {105, 105, 355}, {106, 122, 176}, },
            {{48, 95, -33}, {97, 97, 356}, {98, 122, 176}, },
            {{48, 109, -66}, {110, 110, 357}, {111, 122, 176}, },
            {{48, 110, -54}, {111, 111, 358}, {112, 122, 176}, },
            {{48, 113, -51}, {114, 114, 359}, {115, 122, 176}, },
            {{48, 113, -51}, {114, 114, 360}, {115, 122, 176}, },
            {{48, 110, -54}, {111, 111, 361}, {112, 122, 176}, },
            {{48, 109, -66}, {110, 110, 362}, {111, 122, 176}, },
            {{48, 95, -33}, {97, 108, 176}, {109, 109, 363}, {110, 122, 176}, },
            {{48, 95, -33}, {97, 115, 176}, {116, 116, 364}, {117, 122, 176}, },
            {{48, 113, -51}, {114, 114, 365}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 98, 176}, {99, 99, 366}, {100, 122, 176}, },
            {{48, 110, -54}, {111, 111, 367}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 368}, {103, 115, 176}, {116, 116, 369}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 370}, {102, 122, 176}, },
            {{48, 100, -62}, {101, 101, 371}, {102, 122, 176}, },
            {{48, 95, -33}, {97, 114, 176}, {115, 115, 372}, {116, 122, 176}, },
            {{48, 101, -52}, {102, 102, 373}, {103, 122, 176}, },
            {{48, 95, -33}, {97, 119, 176}, {120, 120, 374}, {121, 122, 176}, },
            {{48, 109, -66}, {110, 110, 375}, {111, 113, 176}, {114, 114, 376}, {115, 122, 176}, },
            {{48, 99, -57}, {100, 100, 377}, {101, 122, 176}, },
            {{48, 115, -234}, {116, 116, 378}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 379}, {115, 122, 176}, },
            {{48, 114, -242}, {115, 115, 380}, {116, 122, 176}, },
            {{48, 100, -62}, {101, 101, 381}, {102, 105, 176}, {106, 106, 382}, {107, 122, 176}, },
            {{48, 109, -66}, {110, 110, 383}, {111, 122, 176}, },
            {{48, 98, -236}, {99, 99, 384}, {100, 107, 176}, {108, 108, 385}, {109, 117, 176}, {118, 118, 386}, {119, 122, 176}, },
            {{48, 95, -33}, {97, 102, 176}, {103, 103, 387}, {104, 122, 176}, },
            {{48, 95, -33}, {97, 112, 176}, {113, 113, 388}, {114, 122, 176}, },
            {{48, 95, -33}, {97, 121, 176}, {122, 122, 389}, },
            {{48, 104, -225}, {105, 105, 390}, {106, 122, 176}, },
            {{48, 109, -66}, {110, 110, 391}, {111, 122, 176}, },
            {{48, 113, -51}, {114, 114, 392}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 97, 176}, {98, 98, 393}, {99, 99, 394}, {100, 122, 176}, },
            {{48, 104, -225}, {105, 105, 395}, {106, 122, 176}, },
            {{48, 95, -33}, {97, 111, 176}, {112, 112, 396}, {113, 122, 176}, },
            {{48, 100, -62}, {101, 101, 397}, {102, 122, 176}, },
            {{48, 104, -225}, {105, 105, 398}, {106, 122, 176}, },
            {{0, 8233, -67}, },
            {{0, 8233, -67}, },
            {},
            {{62, 62, 399}, },
            {{62, 62, 400}, },
            {},
            {{0, 8233, -72}, },
            {{0, 8233, -72}, },
            {},
            {},
            {},
            {{83, 83, 401}, },
            {{83, 83, 402}, },
            {{78, 78, 403}, },
            {{70, 70, 404}, },
            {{80, 80, 405}, {84, 84, 406}, },
            {{82, 82, 407}, },
            {{80, 80, 408}, },
            {{67, 67, 409}, {73, 73, 410}, {86, 86, 411}, },
            {{67, 67, 412}, },
            {{69, 69, 413}, {80, 80, 414}, },
            {{69, 69, 415}, {79, 79, 416}, },
            {{69, 69, 417}, {84, 84, 418}, },
            {{66, 66, 419}, },
            {{69, 69, 420}, },
            {{76, 76, 421}, {82, 82, 422}, },
            {{116, 116, 423}, },
            {{101, 101, 424}, },
            {{117, 117, 425}, },
            {{62, 62, 426}, },
            {{62, 62, 427}, },
            {},
            {{58, 58, 428}, },
            {},
            {{48, 102, -154}, },
            {},
            {{62, 62, 429}, },
            {{62, 62, 430}, },
            {},
            {},
            {},
            {{62, 62, 431}, },
            {{62, 62, 432}, },
            {{48, 83, -186}, {84, 84, 433}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 434}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 435}, {74, 122, -216}, },
            {{48, 75, -191}, {76, 76, 436}, {77, 122, -191}, },
            {{48, 68, -28}, {69, 69, 437}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 438}, {74, 122, -216}, },
            {{48, 66, -196}, {67, 67, 439}, {68, 82, 171}, {83, 83, 440}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 441}, {74, 122, -216}, },
            {{48, 71, -42}, {72, 72, 442}, {73, 122, -45}, },
            {{48, 68, -28}, {69, 69, 443}, {70, 72, 171}, {73, 73, 444}, {74, 122, -216}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 445}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 446}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 447}, {84, 122, -27}, },
            {{48, 48, 170}, {49, 49, 448}, {50, 57, 170}, {65, 122, -33}, },
            {{48, 68, -28}, {69, 69, 449}, {70, 122, -40}, },
            {{48, 75, -191}, {76, 76, 450}, {77, 78, 171}, {79, 79, 451}, {80, 122, -28}, },
            {{48, 75, -191}, {76, 76, 452}, {77, 122, -191}, },
            {{48, 83, -186}, {84, 84, 453}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 454}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 455}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 456}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 457}, {73, 122, -45}, },
            {{48, 72, -31}, {73, 73, 458}, {74, 122, -216}, },
            {{48, 72, -31}, {73, 73, 459}, {74, 122, -216}, },
            {{48, 68, -28}, {69, 69, 460}, {70, 122, -40}, },
            {{48, 48, 170}, {49, 49, 461}, {50, 57, 170}, {65, 84, 171}, {85, 85, 462}, {86, 122, -215}, },
            {{48, 81, -212}, {82, 82, 463}, {83, 122, -32}, },
            {{48, 48, 170}, {49, 49, 464}, {50, 122, -323}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 76, 171}, {77, 77, 465}, {78, 79, 171}, {80, 80, 466}, {81, 122, -195}, },
            {{48, 72, -31}, {73, 73, 467}, {74, 122, -216}, },
            {{48, 82, -174}, {83, 83, 468}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 469}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 470}, {84, 122, -27}, },
            {{48, 76, -340}, {77, 77, 471}, {78, 90, 171}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 472}, {74, 122, -216}, },
            {{48, 83, -186}, {84, 84, 473}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 474}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 475}, {70, 122, -40}, },
            {{48, 78, -180}, {79, 79, 476}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 477}, {84, 122, -27}, },
            {{48, 84, -215}, {85, 85, 478}, {86, 122, -215}, },
            {{48, 72, -31}, {73, 73, 479}, {74, 122, -216}, },
            {{48, 77, -43}, {78, 78, 480}, {79, 81, 171}, {82, 82, 481}, {83, 122, -32}, },
            {{48, 75, -191}, {76, 76, 482}, {77, 122, -191}, },
            {},
            {{48, 115, -234}, {116, 116, 483}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 107, 176}, {108, 108, 484}, {109, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 107, -358}, {108, 108, 485}, {109, 122, 176}, },
            {{48, 100, -62}, {101, 101, 486}, {102, 122, 176}, },
            {{48, 99, -57}, {100, 100, 487}, {101, 122, 176}, },
            {{48, 114, -242}, {115, 115, 488}, {116, 122, 176}, },
            {{48, 98, -236}, {99, 99, 489}, {100, 114, 176}, {115, 115, 490}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 103, 176}, {104, 104, 491}, {105, 122, 176}, },
            {{48, 114, -242}, {115, 115, 492}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 493}, {111, 122, 176}, },
            {{48, 104, -225}, {105, 105, 494}, {106, 122, 176}, },
            {{48, 100, -62}, {101, 101, 495}, {102, 122, 176}, },
            {{48, 112, -255}, {113, 113, 496}, {114, 122, 176}, },
            {{48, 113, -51}, {114, 114, 497}, {115, 122, 176}, },
            {{48, 115, -234}, {116, 116, 498}, {117, 122, 176}, },
            {{48, 115, -234}, {116, 116, 499}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 500}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 108, -233}, {109, 109, 501}, {110, 122, 176}, },
            {{48, 115, -234}, {116, 116, 502}, {117, 122, 176}, },
            {{48, 99, -57}, {100, 100, 503}, {101, 101, 176}, {102, 102, 504}, {103, 122, 176}, },
            {{48, 48, 170}, {49, 49, 505}, {50, 50, 506}, {51, 57, 170}, {65, 122, -33}, },
            {{48, 95, -33}, {97, 106, 176}, {107, 107, 507}, {108, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 103, -366}, {104, 104, 508}, {105, 122, 176}, },
            {{48, 48, 170}, {49, 49, 509}, {50, 122, -323}, },
            {{48, 100, -62}, {101, 101, 510}, {102, 122, 176}, },
            {{48, 111, -262}, {112, 112, 511}, {113, 122, 176}, },
            {{48, 114, -242}, {115, 115, 512}, {116, 122, 176}, },
            {{48, 95, -33}, {97, 116, 176}, {117, 117, 513}, {118, 122, 176}, },
            {{48, 115, -234}, {116, 116, 514}, {117, 122, 176}, },
            {{48, 98, -236}, {99, 99, 515}, {100, 122, 176}, },
            {{48, 107, -358}, {108, 108, 516}, {109, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 517}, {102, 122, 176}, },
            {{48, 110, -54}, {111, 111, 518}, {112, 122, 176}, },
            {},
            {},
            {{84, 84, 519}, },
            {{69, 69, 520}, },
            {{67, 67, 521}, {83, 83, 522}, },
            {{73, 73, 523}, },
            {{82, 82, 524}, },
            {{69, 69, 525}, },
            {{77, 77, 526}, },
            {{79, 79, 527}, },
            {{76, 76, 528}, },
            {{84, 84, 529}, },
            {{65, 65, 530}, },
            {{65, 65, 531}, },
            {{82, 82, 532}, },
            {{65, 65, 533}, },
            {{68, 68, 534}, },
            {{77, 77, 535}, {80, 80, 536}, },
            {{83, 83, 537}, },
            {{83, 83, 538}, },
            {{83, 83, 539}, },
            {{83, 83, 540}, },
            {{85, 85, 541}, },
            {{73, 73, 542}, },
            {{101, 101, 543}, },
            {{100, 100, 544}, },
            {{116, 116, 545}, },
            {},
            {},
            {},
            {},
            {{62, 62, 546}, },
            {},
            {},
            {{48, 81, -212}, {82, 82, 547}, {83, 122, -32}, },
            {{48, 81, -212}, {82, 82, 548}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 549}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 66, -196}, {67, 67, 550}, {68, 122, -198}, },
            {{48, 81, -212}, {82, 82, 551}, {83, 122, -32}, },
            {{48, 83, -186}, {84, 84, 552}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 553}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 554}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 69, -34}, {70, 70, 555}, {71, 122, -184}, },
            {{48, 83, -186}, {84, 84, 556}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 557}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 558}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 83, -186}, {84, 84, 559}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 560}, {70, 122, -40}, },
            {{48, 81, -212}, {82, 82, 561}, {83, 122, -32}, },
            {{48, 84, -215}, {85, 85, 562}, {86, 122, -215}, },
            {{48, 72, -31}, {73, 73, 563}, {74, 122, -216}, },
            {{48, 70, -179}, {71, 71, 564}, {72, 81, 171}, {82, 82, 565}, {83, 122, -32}, },
            {{48, 81, -212}, {82, 82, 566}, {83, 122, -32}, },
            {{48, 75, -191}, {76, 76, 567}, {77, 122, -191}, },
            {{48, 72, -31}, {73, 73, 568}, {74, 122, -216}, },
            {{48, 77, -43}, {78, 78, 569}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 570}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 571}, {77, 122, -191}, },
            {{48, 122, -33}, },
            {{48, 81, -212}, {82, 82, 572}, {83, 122, -32}, },
            {{48, 57, 170}, {65, 65, 573}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -180}, {79, 79, 574}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 575}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 576}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 66, -196}, {67, 67, 577}, {68, 122, -198}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 578}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 579}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 580}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 581}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 582}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 583}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 584}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 585}, {70, 122, -40}, },
            {{48, 95, -33}, {97, 120, 176}, {121, 121, 586}, {122, 122, 176}, },
            {{48, 114, -242}, {115, 115, 587}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 588}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 116, -394}, {117, 117, 589}, {118, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 115, -234}, {116, 116, 590}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 591}, {102, 122, 176}, },
            {{48, 115, -234}, {116, 116, 592}, {117, 122, 176}, },
            {{48, 115, -234}, {116, 116, 593}, {117, 122, 176}, },
            {{48, 119, -244}, {120, 120, 594}, {121, 122, 176}, },
            {{48, 113, -51}, {114, 114, 595}, {115, 122, 176}, },
            {{48, 48, 170}, {49, 49, 596}, {50, 122, -323}, },
            {{48, 95, -33}, {97, 97, 597}, {98, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 110, -54}, {111, 111, 598}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 599}, {103, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 104, -225}, {105, 105, 600}, {106, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -234}, {116, 116, 601}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 115, -234}, {116, 116, 602}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 98, -236}, {99, 99, 603}, {100, 122, 176}, },
            {{48, 113, -51}, {114, 114, 604}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 605}, {111, 122, 176}, },
            {{82, 82, 606}, },
            {{82, 82, 607}, },
            {{82, 82, 608}, },
            {{84, 84, 609}, },
            {{78, 78, 610}, },
            {{69, 69, 611}, },
            {{78, 78, 612}, },
            {{85, 85, 613}, },
            {{82, 82, 614}, },
            {{85, 85, 615}, },
            {{73, 73, 616}, },
            {{82, 82, 617}, },
            {{76, 76, 618}, },
            {{65, 65, 619}, },
            {{84, 84, 620}, },
            {{73, 73, 621}, },
            {{79, 79, 622}, },
            {{69, 69, 623}, },
            {},
            {},
            {{84, 84, 624}, },
            {},
            {{69, 69, 625}, },
            {{65, 65, 626}, },
            {{114, 114, 627}, },
            {{105, 105, 628}, },
            {{104, 104, 629}, },
            {},
            {{48, 57, 170}, {65, 65, 630}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 631}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 632}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 633}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 634}, {66, 81, 171}, {82, 82, 635}, {83, 122, -32}, },
            {{48, 72, -31}, {73, 73, 636}, {74, 122, -216}, },
            {{48, 81, -212}, {82, 82, 637}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 638}, {84, 122, -27}, },
            {{48, 67, -188}, {68, 68, 639}, {69, 122, -188}, },
            {{48, 122, -33}, },
            {{48, 88, -175}, {89, 89, 640}, {90, 122, -41}, },
            {{48, 76, -340}, {77, 77, 641}, {78, 122, -345}, },
            {{48, 83, -186}, {84, 84, 642}, {85, 122, -186}, },
            {{48, 67, -188}, {68, 68, 643}, {69, 122, -188}, },
            {{48, 57, 170}, {65, 65, 644}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 645}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 646}, {74, 122, -216}, },
            {{48, 90, -33}, {95, 95, 647}, {97, 122, 176}, },
            {{48, 77, -43}, {78, 78, 648}, {79, 122, -34}, },
            {{48, 83, -186}, {84, 84, 649}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 650}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 651}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 652}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 653}, {85, 122, -186}, },
            {{48, 81, -212}, {82, 82, 654}, {83, 122, -32}, },
            {{48, 68, -28}, {69, 69, 655}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 656}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 70, -179}, {71, 71, 657}, {72, 122, -179}, },
            {{48, 76, -340}, {77, 77, 658}, {78, 122, -345}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 659}, {84, 122, -27}, },
            {{48, 65, -27}, {66, 66, 660}, {67, 77, 171}, {78, 78, 661}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 662}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 663}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 664}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -234}, {116, 116, 665}, {117, 122, 176}, },
            {{48, 113, -51}, {114, 114, 666}, {115, 122, 176}, },
            {{48, 104, -225}, {105, 105, 667}, {106, 122, 176}, },
            {{48, 119, -244}, {120, 120, 668}, {121, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -234}, {116, 116, 669}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 670}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{65, 65, 671}, },
            {{84, 84, 672}, },
            {{69, 69, 673}, },
            {{65, 65, 674}, {82, 82, 675}, },
            {{73, 73, 676}, },
            {{83, 83, 677}, },
            {{68, 68, 678}, },
            {{76, 76, 679}, },
            {{84, 84, 680}, },
            {{68, 68, 681}, },
            {{65, 65, 682}, },
            {{73, 73, 683}, },
            {{95, 95, 684}, },
            {{84, 84, 685}, },
            {{84, 84, 686}, },
            {{67, 67, 687}, },
            {{84, 84, 688}, },
            {{82, 82, 689}, },
            {{73, 73, 690}, },
            {{83, 83, 691}, },
            {{66, 66, 692}, },
            {{97, 97, 693}, },
            {{99, 99, 694}, },
            {{95, 95, 695}, },
            {{48, 66, -196}, {67, 67, 696}, {68, 122, -198}, },
            {{48, 72, -31}, {73, 73, 697}, {74, 122, -216}, },
            {{48, 122, -33}, },
            {{48, 83, -186}, {84, 84, 698}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 699}, {79, 122, -34}, },
            {{48, 57, 170}, {65, 65, 700}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 701}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 702}, {84, 122, -27}, },
            {{48, 79, -195}, {80, 80, 703}, {81, 122, -195}, },
            {{48, 68, -28}, {69, 69, 704}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 705}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 706}, {70, 122, -40}, },
            {{48, 75, -191}, {76, 76, 707}, {77, 122, -191}, },
            {{48, 81, -212}, {82, 82, 708}, {83, 122, -32}, },
            {{48, 57, 170}, {65, 65, 709}, {66, 122, -37}, },
            {{48, 78, -180}, {79, 79, 710}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 711}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -191}, {76, 76, 712}, {77, 122, -191}, },
            {{48, 72, -31}, {73, 73, 713}, {74, 122, -216}, },
            {{48, 68, -28}, {69, 69, 714}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 715}, {85, 122, -186}, },
            {{48, 76, -340}, {77, 77, 716}, {78, 82, 171}, {83, 83, 717}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -191}, {76, 76, 718}, {77, 122, -191}, },
            {{48, 83, -186}, {84, 84, 719}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 720}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 721}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 119, -244}, {120, 120, 722}, {121, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 723}, {102, 122, 176}, },
            {{67, 67, 724}, },
            {{73, 73, 725}, },
            {{84, 84, 726}, },
            {{78, 78, 727}, },
            {{65, 65, 728}, },
            {{84, 84, 729}, },
            {{83, 83, 730}, },
            {{83, 83, 731}, },
            {{65, 65, 732}, },
            {{83, 83, 733}, },
            {{69, 69, 734}, },
            {{76, 76, 735}, },
            {{65, 65, 736}, },
            {{79, 79, 737}, },
            {{73, 73, 738}, },
            {{69, 69, 739}, },
            {{65, 65, 740}, },
            {{69, 69, 741}, },
            {{84, 84, 742}, },
            {{84, 84, 743}, },
            {},
            {{76, 76, 744}, },
            {{108, 108, 745}, },
            {{97, 97, 746}, },
            {{112, 112, 747}, },
            {{48, 83, -186}, {84, 84, 748}, {85, 122, -186}, },
            {{48, 78, -180}, {79, 79, 749}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 750}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 751}, {85, 122, -186}, },
            {{48, 72, -31}, {73, 73, 752}, {74, 122, -216}, },
            {{48, 72, -31}, {73, 73, 753}, {74, 122, -216}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 754}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 755}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 756}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 757}, {74, 122, -216}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 758}, {79, 122, -34}, },
            {{48, 79, -195}, {80, 80, 759}, {81, 122, -195}, },
            {{48, 122, -33}, },
            {{48, 48, 170}, {49, 49, 760}, {50, 122, -323}, },
            {{48, 78, -180}, {79, 79, 761}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 762}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 763}, {74, 122, -216}, },
            {{48, 68, -28}, {69, 69, 764}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 765}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 48, 170}, {49, 49, 766}, {50, 122, -323}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{84, 84, 767}, },
            {{79, 79, 768}, },
            {{69, 69, 769}, },
            {{84, 84, 770}, },
            {{73, 73, 771}, },
            {{73, 73, 772}, },
            {{73, 73, 773}, },
            {},
            {},
            {},
            {{83, 83, 774}, },
            {{73, 73, 775}, },
            {{78, 78, 776}, },
            {{80, 80, 777}, },
            {{79, 79, 778}, },
            {{82, 82, 779}, },
            {{84, 84, 780}, },
            {{83, 83, 781}, },
            {{73, 73, 782}, },
            {{85, 85, 783}, },
            {{69, 69, 784}, },
            {{95, 95, 785}, },
            {{116, 116, 786}, },
            {{114, 114, 787}, },
            {{48, 90, -33}, {95, 95, 788}, {97, 122, 176}, },
            {{48, 77, -43}, {78, 78, 789}, {79, 122, -34}, },
            {{48, 90, -33}, {95, 95, 790}, {97, 122, 176}, },
            {{48, 82, -174}, {83, 83, 791}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 792}, {79, 122, -34}, },
            {{48, 78, -180}, {79, 79, 793}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 794}, {84, 122, -27}, },
            {{48, 83, -186}, {84, 84, 795}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 796}, {84, 89, 171}, {90, 90, 797}, {95, 122, -27}, },
            {{48, 83, -186}, {84, 84, 798}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 799}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 800}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 801}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 802}, {79, 122, -34}, },
            {{48, 82, -174}, {83, 83, 803}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{95, 95, 804}, },
            {{78, 78, 805}, },
            {{95, 95, 806}, },
            {{83, 83, 807}, },
            {{78, 78, 808}, },
            {{79, 79, 809}, },
            {{79, 79, 810}, },
            {},
            {{83, 83, 811}, },
            {{84, 84, 812}, },
            {{69, 69, 813}, },
            {{78, 78, 814}, },
            {{78, 78, 815}, },
            {{69, 69, 816}, },
            {},
            {{69, 69, 817}, },
            {{84, 84, 818}, },
            {{83, 83, 819}, },
            {{112, 112, 820}, {115, 115, 821}, },
            {{101, 101, 822}, },
            {{101, 101, 823}, },
            {{48, 66, -196}, {67, 67, 824}, {68, 85, 171}, {86, 86, 825}, {87, 122, -196}, },
            {{48, 82, -174}, {83, 83, 826}, {84, 122, -27}, },
            {{48, 66, -196}, {67, 67, 827}, {68, 85, 171}, {86, 86, 828}, {87, 122, -196}, },
            {{48, 122, -33}, },
            {{48, 83, -186}, {84, 84, 829}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 830}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 831}, {66, 122, -37}, },
            {{48, 57, 170}, {65, 65, 832}, {66, 122, -37}, },
            {{48, 57, 170}, {65, 65, 833}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 81, -212}, {82, 82, 834}, {83, 122, -32}, },
            {{48, 82, -174}, {83, 83, 835}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 836}, {84, 122, -27}, },
            {{48, 83, -186}, {84, 84, 837}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{67, 67, 838}, {86, 86, 839}, },
            {{83, 83, 840}, },
            {{67, 67, 841}, {86, 86, 842}, },
            {},
            {{84, 84, 843}, },
            {{78, 78, 844}, },
            {{78, 78, 845}, },
            {{65, 65, 846}, },
            {},
            {{82, 82, 847}, },
            {{83, 83, 848}, },
            {},
            {},
            {{83, 83, 849}, },
            {{73, 73, 850}, },
            {},
            {{114, 114, 851}, },
            {{117, 117, 852}, },
            {{95, 95, 853}, },
            {{100, 100, 854}, },
            {{48, 78, -180}, {79, 79, 855}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 856}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -180}, {79, 79, 857}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 858}, {66, 122, -37}, },
            {{48, 82, -174}, {83, 83, 859}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 860}, {84, 122, -27}, },
            {{48, 83, -186}, {84, 84, 861}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 862}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 863}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 864}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{79, 79, 865}, },
            {{65, 65, 866}, },
            {},
            {{79, 79, 867}, },
            {{65, 65, 868}, },
            {{83, 83, 869}, },
            {{83, 83, 870}, },
            {},
            {{84, 84, 871}, },
            {{65, 65, 872}, },
            {},
            {},
            {{79, 79, 873}, },
            {{101, 101, 874}, },
            {{98, 98, 875}, },
            {{105, 105, 876}, },
            {{105, 105, 877}, },
            {{48, 77, -43}, {78, 78, 878}, {79, 122, -34}, },
            {{48, 81, -212}, {82, 82, 879}, {83, 122, -32}, },
            {{48, 77, -43}, {78, 78, 880}, {79, 122, -34}, },
            {{48, 81, -212}, {82, 82, 881}, {83, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 882}, {74, 122, -216}, },
            {{48, 72, -31}, {73, 73, 883}, {74, 122, -216}, },
            {{48, 72, -31}, {73, 73, 884}, {74, 122, -216}, },
            {{48, 83, -186}, {84, 84, 885}, {85, 122, -186}, },
            {{78, 78, 886}, },
            {{82, 82, 887}, },
            {{78, 78, 888}, },
            {{82, 82, 889}, },
            {},
            {},
            {{73, 73, 890}, },
            {{84, 84, 891}, },
            {{78, 78, 892}, },
            {{100, 100, 893}, },
            {{115, 115, 894}, },
            {{100, 100, 895}, },
            {{99, 99, 896}, },
            {{48, 82, -174}, {83, 83, 897}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 898}, {74, 122, -216}, },
            {{48, 82, -174}, {83, 83, 899}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 900}, {74, 122, -216}, },
            {{48, 78, -180}, {79, 79, 901}, {80, 122, -28}, },
            {{48, 78, -180}, {79, 79, 902}, {80, 122, -28}, },
            {{48, 78, -180}, {79, 79, 903}, {80, 122, -28}, },
            {{48, 72, -31}, {73, 73, 904}, {74, 122, -216}, },
            {{83, 83, 905}, },
            {{73, 73, 906}, },
            {{83, 83, 907}, },
            {{73, 73, 908}, },
            {{79, 79, 909}, },
            {{73, 73, 910}, },
            {},
            {{105, 105, 911}, },
            {{116, 116, 912}, },
            {{101, 101, 913}, },
            {{97, 97, 914}, },
            {{48, 83, -186}, {84, 84, 915}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 916}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 917}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 918}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 919}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 920}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 921}, {79, 122, -34}, },
            {{48, 78, -180}, {79, 79, 922}, {80, 122, -28}, },
            {{84, 84, 923}, },
            {{65, 65, 924}, },
            {{84, 84, 925}, },
            {{65, 65, 926}, },
            {{78, 78, 927}, },
            {{79, 79, 928}, },
            {{99, 99, 929}, },
            {{105, 105, 930}, },
            {{110, 110, 931}, },
            {{116, 116, 932}, },
            {{48, 57, 170}, {65, 65, 933}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 934}, {67, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 935}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 936}, {67, 122, -918}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 937}, {79, 122, -34}, },
            {{65, 65, 938}, },
            {{66, 66, 939}, },
            {{65, 65, 940}, },
            {{66, 66, 941}, },
            {},
            {{78, 78, 942}, },
            {{97, 97, 943}, },
            {{116, 116, 944}, },
            {{116, 116, 945}, },
            {{101, 101, 946}, },
            {{48, 77, -43}, {78, 78, 947}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 948}, {77, 122, -191}, },
            {{48, 77, -43}, {78, 78, 949}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 950}, {77, 122, -191}, },
            {{48, 82, -174}, {83, 83, 951}, {84, 122, -27}, },
            {{78, 78, 952}, },
            {{76, 76, 953}, },
            {{78, 78, 954}, },
            {{76, 76, 955}, },
            {{83, 83, 956}, },
            {{116, 116, 957}, },
            {{117, 117, 958}, },
            {{105, 105, 959}, },
            {},
            {{48, 83, -186}, {84, 84, 960}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 961}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 962}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 963}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{84, 84, 964}, },
            {{69, 69, 965}, },
            {{84, 84, 966}, },
            {{69, 69, 967}, },
            {},
            {{101, 101, 968}, },
            {{116, 116, 969}, },
            {{102, 102, 970}, },
            {{48, 82, -174}, {83, 83, 971}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 972}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 973}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 974}, {84, 122, -27}, },
            {{83, 83, 975}, },
            {{83, 83, 976}, },
            {{83, 83, 977}, },
            {{83, 83, 978}, },
            {{65, 90, 979}, {97, 122, 980}, },
            {{105, 105, 981}, },
            {{105, 105, 982}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {},
            {},
            {},
            {},
            {{65, 122, -970}, },
            {{65, 122, -970}, },
            {{111, 111, 983}, },
            {{101, 101, 984}, },
            {{110, 110, 985}, },
            {{114, 114, 986}, },
            {{65, 90, 987}, {97, 122, 988}, },
            {{65, 90, 989}, {97, 122, 990}, },
            {{65, 122, -987}, },
            {{65, 122, -987}, },
            {{65, 122, -988}, },
            {{65, 122, -988}, },
        }
        { // SHEBANG
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 34, 3}, {35, 35, 4}, {36, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 5}, {11, 12, 5}, {14, 32, 5}, {127, 160, 5}, {8206, 8207, 5}, {8232, 8233, 5}, },
            {},
            {},
            {{33, 33, 6}, },
            {{0, 8233, -3}, },
            {},
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {{42, 42, 7}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 246, 246, 9, -1, 10, 11, 12, 13, 14, 15, 16, 17, 19, 22, 23, 27, 30, 243, 243, 38, 41, 42, 53, 56, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 138, 35, 139, 142, 245, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 198, 200, 199, 205, 169, -1, 17, 12, 28, 105, 113, 95, 24, 44, 25, 58, 202, 55, 51, 20, 9, 10, 197, 38, 31, 23, 201, 13, 170, 36, 140, 205, 34, 50, 62, 48, 33, 47, 32, 61, 127, 85, 96, 128, 203, 52, 21, 57, 60, 49, 204, 206, 207, 208, 43, -1, 8, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, 26, -1, -1, 29, 28, 3, 31, -1, 34, 36, -1, -1, 39, 40, -1, -1, 43, 45, 47, -1, 50, 137, 52, 54, 55, -1, -1, 61, 62, 238, 238, 238, 238, 238, 238, 238, 68, 238, 238, 238, 238, 238, 79, 238, 238, 238, 238, 238, 238, 238, 238, 88, 238, 91, 238, 238, 238, 238, 238, 238, 109, 238, 111, 112, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, 137, 140, -1, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 157, 238, 238, 238, 238, 238, 238, 238, 238, 238, 170, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, 197, -1, 203, 201, -1, -1, 29, 106, 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, 24, 32, -1, 37, 244, 46, 44, -1, 48, 49, 51, 57, 58, 238, 65, 238, 238, 238, 238, 238, 238, 238, 238, 238, 83, 238, 238, 238, 86, 238, 238, 238, 238, 94, 238, 98, 238, 238, 238, 238, 238, 105, 238, 113, 115, 238, 238, 238, 238, 123, 238, 238, 238, 238, 238, 238, 238, 238, 131, 238, 238, 141, 238, 238, 144, 238, 238, 238, 238, 238, 152, 238, 238, 155, 238, 238, 238, 238, 238, 238, 238, 165, 166, 238, 168, 169, 238, 238, 238, 238, 178, 179, 180, 181, 238, 183, 238, 238, 189, 238, 238, 238, 238, 194, 238, 238, 202, 204, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, 25, 33, 207, 206, 59, 60, 238, 238, 238, 70, 72, 238, 238, 238, 238, 238, 81, 238, 238, 238, 238, 87, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 106, 238, 238, 114, 238, 238, 238, 120, 238, 122, 238, 238, 238, 126, 127, 238, 129, 238, 238, 134, 238, 238, 238, 238, 145, 238, 147, 238, 150, 238, 238, 238, 238, 238, 238, 160, 238, 163, 164, 238, 171, 238, 173, 238, 175, 176, 177, 238, 184, 186, 187, 188, 238, 238, 192, 193, 195, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 232, 233, -1, 234, -1, -1, -1, -1, -1, 208, 238, 238, 69, 238, 238, 238, 238, 238, 82, 238, 238, 85, 238, 238, 238, 238, 238, 238, 96, 238, 238, 238, 238, 238, 101, 238, 238, 238, 238, 238, 238, 124, 238, 238, 128, 238, 238, 135, 136, 143, 238, 146, 238, 151, 238, 154, 156, 158, 159, 161, 238, 238, 238, 238, 182, 185, 238, 238, 196, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 66, 73, 238, 238, 238, 238, 80, 110, 238, 238, 238, 238, 238, 238, 238, 238, 238, 238, 103, 104, 238, 238, 238, 238, 238, 121, 125, 102, 130, 238, 238, 71, 238, 153, 238, 167, 238, 174, 190, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 236, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 84, 238, 238, 90, 238, 238, 95, 238, 238, 100, 107, 238, 238, 238, 238, 118, 238, 132, 148, 162, 172, 191, -1, -1, -1, -1, -1, -1, -1, 223, 212, 224, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, 92, 238, 238, 238, 108, 238, 116, 238, 238, 238, 149, -1, -1, -1, -1, -1, -1, -1, 225, -1, -1, -1, -1, -1, -1, 230, -1, -1, -1, -1, -1, -1, 238, 238, 238, 76, 238, 238, 209, 238, 238, 238, 97, 238, 238, 238, 238, 133, -1, -1, -1, 219, -1, -1, -1, -1, 227, -1, -1, 237, 211, -1, -1, 235, -1, -1, -1, -1, 238, 238, 67, 238, 238, 238, 238, 238, 238, 238, 238, 110, 117, 119, -1, -1, 216, -1, -1, -1, 222, 210, -1, -1, 229, 231, -1, -1, -1, -1, -1, 238, 238, 238, 238, 77, 78, 238, 238, 238, 238, -1, -1, -1, -1, 220, 221, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, 213, -1, -1, -1, -1, 238, 238, 238, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 238, 238, 238, 238, 89, 93, 93, 238, -1, -1, -1, -1, 226, -1, -1, -1, -1, -1, 238, 238, 238, 238, 238, -1, -1, -1, -1, -1, -1, -1, -1, 242, 238, 238, 238, 238, 99, -1, -1, -1, -1, 228, -1, -1, -1, 238, 238, 238, 238, -1, -1, -1, -1, 240, -1, -1, 63, 64, 74, 75, 214, 215, 217, 218, 240, 240, -1, -1, -1, -1, 239, 241, 239, 239, 241, 241, },
        // SHEBANG
        {-1, 2, 1, 2, 2, 246, 0, },
        // COMMENT
        {5, 5, 5, 5, 6, 7, 4, 3, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State SHEBANG = new State(1);
        public final static State COMMENT = new State(2);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
